## Controller Python Script "send_feedback_site"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Send feedback to portal administrator
##
REQUEST=context.REQUEST

from Products.CMFPlone.utils import transaction_note
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone import PloneMessageFactory as _
from ZODB.POSException import ConflictError

##
## This may change depending on the called (portal_feedback or author)
state_success = "success"
state_failure = "failure"

plone_utils = getToolByName(context, 'plone_utils')
urltool = getToolByName(context, 'portal_url')
portal = urltool.getPortalObject()
url = urltool()

## make these arguments?
#subject = REQUEST.get('subject', '')
subject = 'Akademie EE Kontaktformular'3
message = REQUEST.get('message', '')
sender_from_address = REQUEST.get('sender_from_address', '')
sender_lastname = REQUEST.get('sender_lastname', '')
sender_firstname = REQUEST.get('sender_firstname', '')

sender_company = REQUEST.get('sender_company', '')
sender_address = REQUEST.get('sender_address', '')
sender_city   = REQUEST.get('sender_city', '') 
sender_phone  = REQUEST.get('sender_phone', '')

stud_interesse = REQUEST.get('sender_from_address', '')
ab_jahr = REQUEST.get('ab_jahr', '')
interesse = REQUEST.get('interesse', '')
schwerpunkt = REQUEST.get('schwerpunkt', '')
about = REQUEST.get('about', '')
frage4 = REQUEST.get('frage4', '')
frage1 = REQUEST.get('frage1', '')
frage2 = REQUEST.get('frage2', '')
frage3 = REQUEST.get('frage3', '')


send_to_address = portal.getProperty('email_from_address')
envelope_from = portal.getProperty('email_from_address')

state.set(status=state_success) ## until proven otherwise

host = context.MailHost # plone_utils.getMailHost() (is private)
encoding = portal.getProperty('email_charset')

variables = {'sender_from_address' : sender_from_address,
             'sender_lastname'     : sender_lastname,     
             'sender_firstname'    : sender_firstname,  
             'sender_company'      : sender_company,
             'sender_address'      : sender_address,
             'sender_city'         : sender_city,
             'sender_phone'        : sender_phone,
             'url'                 : url,
#             'subject'             : subject,
             'message'             : message,
             'stud_interesse'      : stud_interesse,
             'ab_jahr'             : ab_jahr,      
             'interesse'           : interesse,
             'schwerpunkt'         : schwerpunkt,        
             'about'               : about,
             'frage4'              : frage4,
             'frage1'              : frage1,
             'frage2'              : frage2,
             'frage3'              : frage3
             }

try:
    message = context.site_feedback_template(context, **variables)
    result = host.secureSend(message, send_to_address, envelope_from, subject=subject, subtype='plain', charset=encoding, debug=False, From=sender_from_address)
except ConflictError:
    raise
except: # TODO Too many things could possibly go wrong. So we catch all.
    exception = plone_utils.exceptionString()
    message = _(u'Unable to send mail: ${exception}',
                mapping={u'exception' : exception})
    plone_utils.addPortalMessage(message, 'error')
    return state.set(status=state_failure)

## clear request variables so form is cleared as well
REQUEST.set('message', None)
#REQUEST.set('subject', None)
REQUEST.set('sender_from_address', None)
REQUEST.set('sender_lastname', None)
REQUEST.set('sender_firstname', None)
REQUEST.set('sender_company', None)
REQUEST.set('sender_address', None)
REQUEST.set('sender_city', None) 
REQUEST.set('sender_phone', None)
REQUEST.set('ab_jahr', None)
REQUEST.set('interesse', None)
REQUEST.set('schwerpunkt', None)
REQUEST.set('about', None)
REQUEST.set('frage4', None)
REQUEST.set('frage1', None)
REQUEST.set('frage2', None)
REQUEST.set('frage3', None)


plone_utils.addPortalMessage(_(u'Mail sent.'))
return state
